//
// Created by xajhu on 2019/11/18 0018.
//

#ifndef ZTP_CLIENT_ERR_CODE_H
#define ZTP_CLIENT_ERR_CODE_H

#define     ERR_OK          (0)
#define     ERR_ERR         (1)
#define     ERR_UNKNOWN     (2)
#define     ERR_SYSERR      (3)
#define     ERR_NOTFOUND    (4)
#define     ERR_TIMEOUT     (5)

#define     ERR_NULLP       (6)
#define     ERR_NOMEM       (7)
#define     ERR_CHKERR      (8)
#define     ERR_NOTSUPPORT  (9)
#define     ERR_INPUTERR    (10)
#define     ERR_EXIST       (11)
#define     ERR_FULL        (12)
#define     ERR_SENDERR     (13)
#define     ERR_NOCMID      (14)
#define     ERR_SRCERR      (15)
#define     ERR_JSONERR     (16)
#define     ERR_USED        (17)
#define     ERR_OUTSIZE     (18)

#define     ERR_READFILE    (100)

static inline char *err2string(int err)
{
    if(err < 0) {
        err = -err;
    }

    switch(err) {
        case ERR_OK:                    return (char*) "OK";
        case ERR_ERR:                   return (char*) "Error";
        case ERR_UNKNOWN:               return (char*) "Unkown";
        case ERR_SYSERR:                return (char*) "SystemError";
        case ERR_NOTFOUND:              return (char*) "NotFound";
        case ERR_TIMEOUT:               return (char*) "Timeout";
        case ERR_NULLP:                 return (char*) "NullPointer" ;
        case ERR_NOMEM:                 return (char*) "NotEnoughMemory";
        case ERR_CHKERR:                return (char*) "CheckError";
        case ERR_NOTSUPPORT:            return (char*) "NotSupport";
        case ERR_INPUTERR:              return (char*) "InputError";
        case ERR_EXIST:                 return (char*) "AlreadyExist";
        case ERR_FULL:                  return (char*) "Full";
        case ERR_SENDERR:               return (char*) "SendErr";
        case ERR_NOCMID:                return (char*) "CanNotFindConfig";
        case ERR_SRCERR:                return (char*) "ConfigSourceErr";
        case ERR_JSONERR:               return (char*) "JsonFormatErr";
        case ERR_USED:                  return (char*) "ItemUsed";
        case ERR_READFILE:              return (char*) "Read File Error";
        case ERR_OUTSIZE:               return (char*) "Out of memory size";
        default:                        return (char*) "Unknown err code";
    }
}

#endif //ZTP_CLIENT_ERR_CODE_H
