//
// Created by xajhu on 2019/12/3 0003.
//
#include <iostream>

using namespace std;

#include "gtest/gtest.h"

extern "C" {
#include "err_code.h"
#include "ztp_config.h"
}

TEST(config_file_test, load_ztpConfig)
{
    int ret = init_configure("../../dev_confs/ace08484843.conf");
    ASSERT_EQ(ERR_OK, ret);

    PZTP_CONFIG pZtpCfg = get_ztp_configure();

    ASSERT_STREQ(pZtpCfg->svr_cfg.server_url, "cmhi.ztp.com");
    ASSERT_EQ(10082, pZtpCfg->svr_cfg.port);

    PDEVICE_CONFIG pDevCfg = get_device_configure();

    ASSERT_EQ(pDevCfg->port_cfg[0].port_type, WAN_PORT);
    ASSERT_EQ(pDevCfg->port_cfg[0].port_protocol, DHCP_TYPE);

    ASSERT_EQ(pDevCfg->port_cfg[1].port_type, WAN_PORT);
    ASSERT_EQ(pDevCfg->port_cfg[1].port_protocol, STATIC_TYPE);

    ASSERT_EQ(pDevCfg->lan_config.ip_type, IPV4_TYPE);
    ASSERT_STREQ(pDevCfg->lan_config.ip_addr, "192.168.1.1");
    ASSERT_STREQ(pDevCfg->lan_config.netmask, "255.255.255.0");
}
